## libgd2 2.0.1

=== Makefile ===
#Depending on your system and the libraries and features you have
#and want, you WILL need to modify this Makefile!

#If you do not have gcc, change the setting for COMPILER, but you must
#use an ANSI standard C compiler (NOT the old SunOS 4.1.3 cc
#compiler; get gcc if you are still using that). 
COMPILER=gcc

#If the ar command fails on your system, consult the ar manpage
#for your system. 
AR=ar

#Typical configuration: support for PNG images, JPEG images, and FreeType text.
#Remove -DHAVE_LIBFREETYPE if you can live without FreeType text.
#Add -DHAVE_XPM if you have X and xpm installed and you want that feature.

CFLAGS=-g -DHAVE_LIBPNG -DHAVE_LIBJPEG -DHAVE_LIBFREETYPE

#PLEASE NOTE: YOU MAY HAVE TO JUGGLE THE ORDER OF THE LIBRARIES.
#Some systems are very picky about link order. They don't all agree
#on the right order, either. 
#
#Best for most users. If you don't have FreeType, remove -lfreetype.
#Add -lxpm if you need XPM support.

LIBS=-lgd -lpng -lz -ljpeg -lfreetype -lm

#Typical install locations for freetype 2.0, zlib, xpm, libjpeg 
#and libpng header files. If yours are somewhere else, change this. 
#-I. is important to ensure that the version of gd you are installing 
#is used, and not an older release in your directory tree somewhere.

INCLUDEDIRS=-I. -I/usr/include/freetype2 -I/usr/include/X11 -I/usr/X11R6/include/X11 -I/usr/local/include 

#Typical install locations for freetype, zlib, xpm and libpng libraries.
#If yours are somewhere else, other than a standard location
#such as /lib or /usr/lib, then change this. This line shouldn't hurt 
#if you don't actually have some of the optional libraries and directories.
LIBDIRS=-L/usr/local/lib -L/usr/lib/X11 -L/usr/X11R6/lib

#Location where libgd.so should be installed by "make install".
#THIS MUST BE ONE OF YOUR STANDARD SHARED LIBRARY LOCATIONS, unless
#you add a new directory to your LD_LIBRARY_PATH environment setting.
#Otherwise applications will NOT find libgd.so and will produce an 
#error.  
INSTALL_LIB=/usr/lib

#Location where .h files should be installed by "make install".
INSTALL_INCLUDE=/usr/include

#Location where useful non-test programs should be installed by "make install".
INSTALL_BIN=/usr/local/bin

#
#
# Changes should not be required below here.
#
#

# Update these with each release!

MAJOR_VERSION=2
VERSION=2.0.0

CC=$(COMPILER) $(INCLUDEDIRS)
LINK=$(CC) $(LIBDIRS) $(LIBS)

PROGRAMS=$(BIN_PROGRAMS) $(TEST_PROGRAMS)

BIN_PROGRAMS=pngtogd pngtogd2 gdtopng gd2topng gd2copypal gdparttopng webpng
TEST_PROGRAMS=gdtest gddemo gd2time gdtestft testac

default: instructions

instructions:
	@echo First, edit this Makefile. Read the comments at
	@echo the beginning thoroughly.
	@echo
	@echo Second, type \'make install\' as root.
	@echo
	@echo This installs the GD ${VERSION} shared library,
	@echo which is required in order to use the included
	@echo utility programs, such as webpng, pngtogd, etc.
	@echo 
	@echo OPTIONAL third step: type \'make test\' to build 
	@echo the optional test programs. Type \'make install\' FIRST.

test: $(TEST_PROGRAMS)

install: libgd.so.${VERSION} $(BIN_PROGRAMS)
	sh ./install-item 755 pngtogd $(INSTALL_BIN)/pngtogd
	sh ./install-item 755 pngtogd2 $(INSTALL_BIN)/pngtogd2
	sh ./install-item 755 gdtopng $(INSTALL_BIN)/gdtopng
	sh ./install-item 755 gd2topng $(INSTALL_BIN)/gd2topng
	sh ./install-item 755 gd2copypal $(INSTALL_BIN)/gd2copypal
	sh ./install-item 755 gdparttopng $(INSTALL_BIN)/gdparttopng
	sh ./install-item 755 webpng $(INSTALL_BIN)/webpng
	sh ./install-item 755 bdftogd $(INSTALL_BIN)/bdftogd
	sh ./install-item 644 gd.h $(INSTALL_INCLUDE)/gd.h
	sh ./install-item 644 gdcache.h $(INSTALL_INCLUDE)/gdcache.h
	sh ./install-item 644 gd_io.h $(INSTALL_INCLUDE)/gd_io.h
	sh ./install-item 644 gdfontg.h $(INSTALL_INCLUDE)/gdfontg.h
	sh ./install-item 644 gdfontl.h $(INSTALL_INCLUDE)/gdfontl.h
	sh ./install-item 644 gdfontmb.h $(INSTALL_INCLUDE)/gdfontmb.h
	sh ./install-item 644 gdfonts.h $(INSTALL_INCLUDE)/gdfonts.h
	sh ./install-item 644 gdfontt.h $(INSTALL_INCLUDE)/gdfontt.h

gddemo: gddemo.o
	$(CC) gddemo.o -o gddemo	$(LIBDIRS) $(LIBS)

testac: testac.o
	$(CC) testac.o -o testac	$(LIBDIRS) $(LIBS)

pngtogd: pngtogd.o
	$(CC) pngtogd.o -o pngtogd	$(LIBDIRS) $(LIBS) 

webpng: webpng.o
	$(CC) webpng.o -o webpng	$(LIBDIRS) $(LIBS)

pngtogd2: pngtogd2.o
	$(CC) pngtogd2.o -o pngtogd2	$(LIBDIRS) $(LIBS)

gdtopng: gdtopng.o
	$(CC) gdtopng.o -o gdtopng	$(LIBDIRS) $(LIBS)

gd2topng: gd2topng.o
	$(CC) gd2topng.o -o gd2topng	$(LIBDIRS) $(LIBS)

gd2copypal: gd2copypal.o
	$(CC) gd2copypal.o -o gd2copypal	$(LIBDIRS) $(LIBS)

gdparttopng: gdparttopng.o
	$(CC) gdparttopng.o -o gdparttopng	$(LIBDIRS) $(LIBS)

gdtest: gdtest.o
	$(CC) gdtest.o -o gdtest	$(LIBDIRS) $(LIBS)

gd2time: gd2time.o
	$(CC) gd2time.o -o gd2time	$(LIBDIRS) $(LIBS)

gdtestft: gdtestft.o
	$(CC) --verbose gdtestft.o -o gdtestft $(LIBDIRS) $(LIBS)

LIBOBJS=gd.o gd_gd.o gd_gd2.o gd_io.o gd_io_dp.o \
		gd_io_file.o gd_ss.o gd_io_ss.o gd_png.o gd_jpeg.o gdxpm.o \
		gdfontt.o gdfonts.o gdfontmb.o gdfontl.o gdfontg.o \
		gdtables.o gdft.o gdcache.o gdkanji.o wbmp.o \
		gd_wbmp.o gdhelpers.o gd_topal.o 

#Shared library. This should work fine on any ELF platform (Linux, etc.) with
#GNU ld or something similarly intelligent. To avoid the chicken-and-egg
#problem, this target also installs the library so that applications can
#actually find it.

libgd.so.${VERSION}: ${LIBOBJS}
	-rm -f libgd.so.${VERSION} 2>/dev/null
	ld -shared -o libgd.so.${VERSION} ${LIBOBJS}
	sh ./install-item 644 libgd.so.${VERSION} \
		$(INSTALL_LIB)/libgd.so.${VERSION}
	-rm $(INSTALL_LIB)/libgd.so.${MAJOR_VERSION} 2>/dev/null
	ln -s $(INSTALL_LIB)/libgd.so.${VERSION} \
		$(INSTALL_LIB)/libgd.so.${MAJOR_VERSION}	
	-rm $(INSTALL_LIB)/libgd.so 2>/dev/null
	ln -s $(INSTALL_LIB)/libgd.so.${VERSION} \
		$(INSTALL_LIB)/libgd.so	

#Static library, if you really need one for some reason.
libgd.a: ${LIBOBJS}
	rm -f libgd.a
	$(AR) rc libgd.a ${LIBOBJS}
	-ranlib libgd.a

clean:
	rm -f *.o *.a *.so ${PROGRAMS} test/gdtest.jpg test/gdtest.wbmp

## libgd2 2.0.34

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.4.3 FATAL_ERROR)
PROJECT(GD)

SET(CMAKE_MODULE_PATH "${GD_SOURCE_DIR}/cmake/modules")

if (BUILD_TEST)
	ENABLE_TESTING()
endif(BUILD_TEST)

if (USE_EXT_GD)
	message("Using GD at: ${USE_EXT_GD}")
	INCLUDE_DIRECTORIES(BEFORE ${GD_INCLUDE_DIR})
	FIND_PACKAGE(GD)
	if (GD_FOUND)
		INCLUDE_DIRECTORIES(BEFORE ${GD_INCLUDE_DIR})
		LINK_DIRECTORIES(BEFORE ${GD_LIBRARIES})
		SET(GD_LIB ${GD_LIBRARIES})
		SET(GD_LIBS_DIR ${GD_LIBRARY})

		message("GD libs #: ${GD_LIBRARIES}")
		message("GD lib #: ${GD_LIBRARY}")
		message("GD include: ${GD_INCLUDE_DIR}")
	else (GD_FOUND)
		message("No gd found")
	endif (GD_FOUND)
else (USE_EXT_GD)
	SET(GD_VERSION_MAJOR "2")
	SET(GD_VERSION_MINOR "0x0")
	SET(GD_VERSION_PATCH "34")
	SET(GD_VERSION "${GD_VERSION_MAJOR}.${GD_VERSION_MINOR}.${GD_VERSION_PATCH}")
	SET(GD_VERSION_STRING "${GD_VERSION}")

	SET(GD_VERSION_INT "20234")

	SET(PACKAGE GD)
	SET(PACKAGE_NAME GD)

	SET(CMAKE_REQUIRED_INCLUDES "/usr/include" "/usr/local/include")

	message(STATUS "ft2build: ${CMAKE_REQUIRED_INCLUDES}")

	include(CheckIncludeFiles)
	include(CheckIncludeFile)


	include(AC_HEADER_STDC)
	include(CheckPrototypeExists)

	FIND_PACKAGE(PNG REQUIRED)
	FIND_PACKAGE(ZLIB)
	FIND_PACKAGE(JPEG)
	FIND_PACKAGE(PTHREAD)
	FIND_PACKAGE(Freetype)
	FIND_PACKAGE(XPM)
	FIND_PACKAGE(Fontconfig)

	if (FREETYPE_FOUND)
		INCLUDE_DIRECTORIES(${FREETYPE_INCLUDE_DIR})
		message(STATUS "ft2build: ${HAVE_FT2BUILD_H} ${FREETYPE_INCLUDE_DIR}")
		SET(HAVE_FT2BUILD_H 1)
		SET(HAVE_LIBFREETYPE 1)
	ENDIF(FREETYPE_FOUND)

	IF(ZLIB_FOUND)
		INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})
		SET(HAVE_LIBZ 1)
		SET(HAVE_LIBPNG_PNG_H 1)
	ENDIF(ZLIB_FOUND)

	IF(PNG_FOUND)
		INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})
		SET(HAVE_LIBPNG 1)
	ENDIF(PNG_FOUND)

	IF(XPM_FOUND)
		INCLUDE_DIRECTORIES(${XPM_INCLUDE_DIR})
		SET(HAVE_LIBXPM 1)
	ENDIF(XPM_FOUND)

	IF(JPEG_FOUND)
		INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})
		SET(HAVE_LIBJPEG 1)
	ENDIF(JPEG_FOUND)

	IF(FONTCONFIG_FOUND)
		INCLUDE_DIRECTORIES(${FONTCONFIG_INCLUDE_DIR})
		SET(HAVE_LIBFONTCONFIG 1)
	ENDIF(FONTCONFIG_FOUND)

	#FIND_PATH(HAVE_ERRNO_H errno.h)
	#FIND_PATH(HAVE_STRINGS_H strings.h)
	#FIND_PATH(HAVE_LIMITS_H limits.h )
	#SET(HAVE_ERRNO_H 1)
	#SET(HAVE_LIBM 1)
	#FIND_PATH(HAVE_MEMORY_H memory.h)

	#FIND_PATH(HAVE_STRING_H string.h)
	#FIND_PATH(HAVE_SYS_STAT_H 1)
	#FIND_PATH(HAVE_SYS_TYPES_H 1)
	#FIND_PATH(HAVE_UNISTD_H unistd.h)
	#FIND_PATH(STDC_HEADERS 1)
	#FIND_PATH(HAVE_INTTYPES_H 1)
	#FIND_PATH(HAVE_STDDEF_H stddef.h)
	#FIND_PATH(HAVE_STDINT_H 1)
	#FIND_PATH(HAVE_STDLIB_H stdlib.h)

	SET(HAVE_CONFIG_H 1)

	ADD_DEFINITIONS(-DHAVE_CONFIG_H)

	SET (LIBGD_SRC_FILES
		gd.c
		gdfx.c
		gd_security.c
		gd_gd.c
		gd_gd2.c
		gd_io.c
		gd_io_dp.c
		gd_gif_in.c
		gd_gif_out.c
		gd_io_file.c
		gd_io_ss.c
		gd_jpeg.c
		gd_png.c
		gd_ss.c
		gd_topal.c
		gd_wbmp.c
		gdcache.c
		gdfontg.c
		gdfontl.c
		gdfontmb.c
		gdfonts.c
		gdfontt.c
		gdft.c
		gdhelpers.c
		gdhelpers.h
		gdkanji.c
		gdtables.c
		gdxpm.c
		jisx0208.h
		wbmp.c
		wbmp.h
	)

	set(BUILD_SHARED_LIBS On)

	INCLUDE_DIRECTORIES(BEFORE ${GD_SOURCE_DIR}/)

	CONFIGURE_FILE(config.h.cmake config.h ESCAPE_QUOTES)

	add_library(gd ${LIBGD_SRC_FILES})
	target_link_libraries(gd ${FREETYPE_LIBRARIES} ${PNG_LIBRARIES} ${JPEG_LIBRARIES} ${XPM_LIBRARIES} ${FONTCONFIG_LIBRARIES})
	SET(GD_LIB gd)
endif (USE_EXT_GD)

add_subdirectory(tests)

=== windows/Makefile ===
# Makefile form Microsoft C++ nmake.exe
# $Id: Makefile,v 1.5 2006/05/17 15:53:11 edink Exp $

CC=cl.exe
LD=link.exe

BUILD=Release

LIBGDCFLAGS= \
   /D PATHSEPARATOR="\";\"" \
   /D DEFAULT_FONTPATH="\"C:\\WINDOWS\\FONTS;C:\\WINNT\\FONTS\"" \
   /D HAVE_FT2BUILD_H \
   /D HAVE_LIBZ \
   /D HAVE_GD_BUNDLED=1  \
   /D HAVE_GD_GIF_READ=1  \
   /D HAVE_GD_GIF_CREATE=1  \
   /D HAVE_GD_IMAGESETBRUSH=1  \
   /D HAVE_GD_IMAGESETTILE=1 \
   /D HAVE_GD_JPG  \
   /D HAVE_GD_PNG  \
   /D HAVE_GD_STRINGFTEX=1  \
   /D HAVE_GD_STRINGTTF=1  \
   /D HAVE_GD_XBM  \
   /D HAVE_LIBFREETYPE=1  \
   /D HAVE_LIBJPEG  \
   /D HAVE_LIBPNG  \
   /D USE_GD_IMGSTRTTF

CFLAGS=-I. -I.. -nologo -DWIN32 -D_WIN32 -DMSWIN32 -DBGDWIN32 $(LIBGDCFLAGS)

LIBS=libjpeg.lib freetype2.lib libpng.lib zlib.lib kernel32.lib user32.lib advapi32.lib

!if "$(BUILD)" == "Debug"
CFLAGS=$(CFLAGS) /Od /Zi /MDd /D_DEBUG /LDd
LDFLAGS=/DEBUG $(LDFLAGS) /nodefaultlib:msvcrt.lib
LIBS=$(LIBS) msvcrtd.lib
!else
CFLAGS=$(CFLAGS) /Og /Oi /O2 /Oy /GF /MD /DNDEBUG /LD
LDFLAGS=/nodefaultlib:msvcrtd.lib
LIBS=$(LIBS) msvcrt.lib
!endif
CPPFLAGS=$(CFLAGS)

!if "$(DLLNAME)" == ""
DLLNAME=bgd.dll
!endif

DYNAMICLIB=$(DLLNAME:.dll=.lib)

!if "$(STATICLIB)" == ""
STATICLIB=bgd_a.lib
!endif

OBJS= \
  gd.obj \
	gdcache.obj \
  gdfontg.obj \
  gdfontl.obj \
  gdfontmb.obj \
  gdfonts.obj \
  gdfontt.obj \
  gdft.obj \
  gdfx.obj \
  gd_gd2.obj \
  gd_gd.obj \
  gd_gif_in.obj \
  gd_gif_out.obj \
  gdhelpers.obj \
  gd_io.obj \
  gd_io_dp.obj \
  gd_io_file.obj \
  gd_io_ss.obj \
  gd_jpeg.obj \
  gd_security.obj \
  gdkanji.obj \
  gd_png.obj \
  gd_ss.obj \
  gdtables.obj \
  gd_topal.obj \
  gd_wbmp.obj \
  gdxpm.obj \
  wbmp.obj

EXE_OBJS= \
  annotate.obj \
  circletexttest.obj \
  fontconfigtest.obj \
  fontsizetest.obj \
  fontwheeltest.obj \
	gd2copypal.obj \
	gd2togif.obj \
	gd2topng.obj \
	gdcmpgif.obj \
	gdparttopng.obj \
	gdtopng.obj \
	giftogd2.obj \
  gdtest.obj \
  gdtestft.obj \
  gifanimtest.obj \
  pngtogd.obj \
  pngtogd2.obj \
  testac.obj \
  testtr.obj \
  webpng.obj
  
  
all: $(DLLNAME) $(STATICLIB) tests

$(EXE_OBJS:.obj=.exe): $*.obj $(DLLNAME)
	link /out:$*.exe $*.obj $(DYNAMICLIB)

tests: $(EXE_OBJS:.obj=.exe)

libgd.dll.res: libgd.rc
	$(RC) /fo libgd.dll.res libgd.rc

{..}.c.obj:
	$(CC) $(CFLAGS) -c $<

$(STATICLIB): $(OBJS)
	$(LD) /lib /out:$(STATICLIB) $(OBJS)
	
$(DLLNAME): $(OBJS) libgd.dll.res
	$(LD) /dll /out:$(DLLNAME) \
		$(LDFLAGS) \
		$(OBJS) \
		libgd.dll.res \
		$(LIBS)
		
dist: all
	-rmdir /s /q distro
	mkdir distro
	mkdir distro\bin
	copy *.exe distro\bin
	copy *.dll distro\bin
	mkdir distro\include
	copy ..\*.h distro\include
	mkdir distro\lib
	copy *.lib distro\lib
	copy ..\COPYING distro\COPYING.TXT

clean:
	-del /q *.obj *.dll *.lib *.ilk *.pdb *.exp *.exe *.png
	-rmdir /s /q distro

## libgd2 2.0.36~rc1~dfsg

=== debian/changelog ===
libgd2 (2.0.36~rc1~dfsg-6) unstable; urgency=low

  * Acknowledge NMU.
    Closes: bug#619537, #621612. Thanks to Luk Claes.
  * Rewrite copyright file using draft 174 of DEP-5 format.
  * Add patch 0003 to fix support large images.
    Closes: bug#595368. Thanks to Teodor Milkov.
  * Add patch 0004 to fix printf string formatting.
    Closes: bug#643422. Thanks to Didier Raboud and Thorsten Glaser.
  * Bump Standards-Version to 3.9.2.
  * Bump debhelper compatibility level to 7.
  * Update package relations:
    + Tighten build-dependency on cdbs: Needed to support debhelper 7.
    + Relax build-depend unversioned on debhelper and devscripts: Needed
      versions satisfied even in oldstable.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 15 Oct 2011 22:23:42 +0200

libgd2 (2.0.36~rc1~dfsg-5.1) unstable; urgency=low

  * Non-maintainer upload.
  * Remove references to other libraries from dependency_libs field
    Closes: #619537,#621612.

 -- Luk Claes <luk@debian.org>  Mon, 30 May 2011 07:51:27 +0200

libgd2 (2.0.36~rc1~dfsg-5) unstable; urgency=low

  * Workaround CDBS not honoring per-flavor configure flags yet.
    Closes: bug#595709. Thanks to brian m. carlson.
  * Ease building with git-buildpackage:
    + Git-ignore quilt .pc dir.
    + Add dpkg source local-options.
  * Update copyright-check suppression:
    + Fix add ./ prefix.
    + Suppress demo/test graphics.
    + Avoid suppressing the whole debian subdir.

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 17 Oct 2010 15:11:45 +0200

libgd2 (2.0.36~rc1~dfsg-4) unstable; urgency=low

  * Acknowledge NMUs. Thanks to Giuseppe Iuculano and Robert Lemmen.
  * Drop local CDBS snippets: All included in main cdbs package now. As
    local snippets conflicted with recent releases of the cdbs package
    this closes: bug#564374. Thanks to Lucas Nussbaum and Philipp Kern.
    Tighten build-dependency on cdbs.
  * Use dpkg source format "3.0 (quilt)". Drop patchsys-quilt.mk and
    related dependencies.
  * Packaging moved to Git:
    + Update Vcs-* stanzas.
    + Add git-buildpackage config enabling pristine-tar and signed tags.
  * Add README.source documenting use of CDBS and git-buildpackage, and
    drop README.cdbs-tweaks. Drop cdbs comments in debian/rules.
  * Add DEP3 hints ot patch.
  * Update packaging hall of shame in TODO.
  * Rewrite debian/copyright using draft DEP5 format rev. 135.
  * Preserve (not clean) upstream-shipped tempfile during build.
  * Depend on ${misc:Depends}. Thanks to lintian.
  * Bump up standards-version to 3.9.1.
  * Use $(filter ...) instead of $(findstring ...) to extract space-
    separated options from DEB_BUILD_OPTIONS in debian/rules.
  * Build-depend unversioned on d-shlibs (needed version satisfied in
    oldstable).

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 05 Sep 2010 14:36:52 +0200

libgd2 (2.0.36~rc1~dfsg-3.2) unstable; urgency=low

  * Non-maintainer upload.
  * Fixed libjpeg dependency (Closes: #569682)

 -- Robert Lemmen <robertle@semistable.com>  Tue, 23 Mar 2010 17:06:39 +0000

libgd2 (2.0.36~rc1~dfsg-3.1) unstable; urgency=high

  * Non-maintainer upload by the Security Team.
  * Fixed CVE-2009-3546: possible buffer overflow or buffer over-read attacks
    via crafted files (Closes: #552534)

 -- Giuseppe Iuculano <iuculano@debian.org>  Mon, 09 Nov 2009 21:19:11 +0100

libgd2 (2.0.36~rc1~dfsg-3) unstable; urgency=medium

  * Drop bogus "-Wl,--disable-rpath" ld flags.  Closes: bug#478534,
    #476018, thanks to Kumar Appaiah.
  * Install (cleaned copy of) index.html as both README and README.html.
  * Build-depend on html2text (pulled in by debhelper too, but also used
    explicitly so we must depend on it ourselves according to Policy).
  * Update local cdbs snippets:
    + Add and use local autotools.mk extended to support multiple build
      flavors (instead of custom-invoked configure + make).
      As extra bonus this fixes support for cross-compilation (thanks to
      Kumar Appaiah for pointing it out in bug#476018).
    + Add local autotools-vars.mk, makefile.mk and makefile-vars.mk
      needed by local autotools.mk above.
    + Strip non-printable characters in copyright-check.mk.
    + Relaxed copyright-check.mk to only warn by default.
    + Update dependency cleanup to strip cdbs 0.4.27 (not 0.4.27-1).
  * Update debian/copyright-hints.
  * Bump debhelper compatibility level to 6.
  * Semi-auto-update debian/control to update build-dependencies:
      DEB_AUTO_UPDATE_DEBIAN_CONTROL=yes fakeroot debian/rules clean
  * Set urgency=medium as this fixes serious FTBFS bugs.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 28 Jun 2008 16:54:40 +0200

libgd2 (2.0.36~rc1~dfsg-2) unstable; urgency=medium

  * Add symbols file.
  * Add patch 0001 to fix leak in gdImageCopyResized.
  * Set urgency=medium, as the bugfix above seems security-related.
  * Update local cdbs snippets:
    + Enable patchsys-quilt.mk.
    + Major improvements to update-tarball (but none of them affecting
      this current packaging).
    + Major improvements to copyright-check, including new versioned
      build-dependency on devscripts.  Update debian/copyright_hints.
      Closes: bug#466642.
    + Drop buildcore.mk override.  Set DEB_AUTO_UPDATE_DEBIAN_CONTROL
      directly instead when needed.
    + Update debian/README.cdbs-tweaks
  * Avoid copyright-check choking on config/install.sh and aclocal.m4.
  * Semi-auto-update debian/control to update build-dependencies:
    DEB_AUTO_UPDATE_DEBIAN_CONTROL=yes fakeroot debian/rules clean

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 12 Apr 2008 00:49:13 +0200

libgd2 (2.0.36~rc1~dfsg-1) unstable; urgency=medium

  * New upstream prerelease.
    + Fixed gdImageCopy with true color image, the transparent color was
      ignored
    + Fixed support of PNG grayscale image with alpha channel
    + _gdCreateFromFile() can crash if gdImageCreate fails
    + gdImageCreateFrom*Ptr() can crash if gdNewDynamicCtxEx() fails


=== debian/control ===
Source: libgd2
Section: graphics
Priority: optional
Maintainer: GD team <pkg-gd-devel@lists.alioth.debian.org>
Uploaders: Jonas Smedegaard <dr@jones.dk>, Sean Finney <seanius@debian.org>
Build-Depends: autotools-dev,
 gnulib,
 cdbs (>= 0.4.72~),
 debhelper,
 dh-buildinfo,
 devscripts,
 libpng12-dev,
 libz-dev,
 libjpeg-dev,
 libfreetype6-dev,
 libxpm-dev,
 libx11-dev,
 libxt-dev,
 libfontconfig-dev,
 d-shlibs,
 html2text
Vcs-Git: git://git.debian.org/git/collab-maint/libgd2
Vcs-Browser: http://git.debian.org/?p=collab-maint/libgd2.git;a=summary
Standards-Version: 3.9.2
Homepage: http://www.libgd.org/

Package: libgd-tools
Architecture: any
Depends: ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}
Suggests: libgd2-noxpm-dev | libgd2-xpm-dev
Description: GD command line tools and example code
 GD is a graphics library. It allows your code to quickly draw images
 complete with lines, arcs, text, multiple colours, cut and paste from
 other images, flood fills, and write out the result as a PNG file.
 This is particularly useful in World Wide Web applications, where PNG is
 one of the formats accepted for inline images by most browsers.
 .
 This is some simple command line tools and example code that use the GD
 graphics library.

Package: libgd2-xpm-dev
Architecture: any
Section: libdevel
Depends: libgd2-xpm (= ${binary:Version}), ${devlibs:Depends}, ${misc:Depends}
Conflicts: libgd-dev, libgd-noxpm-dev, libgd-xpm-dev, libgd2-noxpm-dev
Provides: libgd-dev
Description: GD Graphics Library version 2 (development version)
 GD is a graphics library. It allows your code to quickly draw images
 complete with lines, arcs, text, multiple colours, cut and paste from
 other images, flood fills, and write out the result as a PNG file.
 This is particularly useful in World Wide Web applications, where PNG is
 one of the formats accepted for inline images by most browsers.
 .
 This is the full development version of the library, built with XPM
 (X pixmap) and fontconfig support.

Package: libgd2-noxpm-dev
Architecture: any
Section: libdevel
Depends: libgd2-noxpm (= ${binary:Version}), ${devlibs:Depends}, ${misc:Depends}
Conflicts: libgd-dev, libgd-noxpm-dev, libgd-xpm-dev, libgd2-xpm-dev
Provides: libgd-dev
Description: GD Graphics Library version 2 (development version)
 GD is a graphics library. It allows your code to quickly draw images
 complete with lines, arcs, text, multiple colours, cut and paste from
 other images, flood fills, and write out the result as a PNG file.
 This is particularly useful in World Wide Web applications, where PNG is
 one of the formats accepted for inline images by most browsers.
 .
 This is the full development version of the library, built without XPM
 (X pixmap) or fontconfig support.

Package: libgd2-xpm
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libgd2, libgd2-noxpm
Provides: libgd2
Suggests: libgd-tools
Description: GD Graphics Library version 2
 GD is a graphics library. It allows your code to quickly draw images
 complete with lines, arcs, text, multiple colours, cut and paste from
 other images, flood fills, and write out the result as a PNG file.
 This is particularly useful in World Wide Web applications, where PNG is
 one of the formats accepted for inline images by most browsers.
 .
 This is the runtime package of the library, built with XPM (X pixmap)
 and fontconfig support.

Package: libgd2-noxpm
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libgd2, libgd2-xpm
Provides: libgd2
Suggests: libgd-tools
Description: GD Graphics Library version 2 (without XPM support)
 GD is a graphics library. It allows your code to quickly draw images
 complete with lines, arcs, text, multiple colours, cut and paste from
 other images, flood fills, and write out the result as a PNG file.
 This is particularly useful in World Wide Web applications, where PNG is
 one of the formats accepted for inline images by most browsers.
 .
 This is the runtime package of the library, built without XPM (X pixmap)
 or fontconfig support.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2002-2010 Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for GD
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

DEB_BUILDDIR = build
DEB_MAKE_FLAVORS = noxpm xpm
include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk

DEB_UPSTREAM_PACKAGE = gd
DEB_UPSTREAM_URL = http://www.libgd.org/releases
DEB_UPSTREAM_TARBALL_VERSION_MANGLE = s/~rc/RC/
DEB_UPSTREAM_TARBALL_MD5 = 39ac48e6d5e0012a3bd2248a0102f209

# Upstream source contains copyrights with questionable or missing licenses
DEB_UPSTREAM_REPACKAGE_EXCLUDE = cmake tests VMS

# Avoid copyright-check choking on config/install.sh and aclocal.m4
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^(demoin\.gif|test/gdtest.*.png|(.*/)?config\.(guess|sub|rpath)(\..*)?|config/install-sh|aclocal\.m4|debian/(changelog|copyright(|_hints|_newhints)))$

pkgname = libgd2
libname = libgd

# Install multiple flavors to separate destinations
# TODO: drop unneeded pkgname from skel (included to minimize transition patch)
DEB_MAKE_DESTDIRSKEL = $(CURDIR)/debian/tmp-$(pkgname)-@FLAVOR@
# TODO: stop setting DEB_DESTDIR when DEB_MAKE_DESTDIRSKEL is actually used
DEB_DESTDIR = $(CURDIR)/debian/tmp-$(pkgname)-$(cdbs_make_curflavor)/

DEB_CONFIGURE_FLAGS_noxpm = --without-x --without-xpm --without-fontconfig
DEB_CONFIGURE_FLAGS_xpm = --with-x
DEB_CONFIGURE_EXTRA_FLAGS = --disable-rpath

DEB_DH_MAKESHLIBS_ARGS_libgd2-noxpm = -V'libgd2-noxpm (>= $(DEB_UPSTREAM_VERSION)) | libgd2-xpm (>= $(DEB_UPSTREAM_VERSION))'
DEB_DH_MAKESHLIBS_ARGS_libgd2-xpm = -V'libgd2-xpm (>= $(DEB_UPSTREAM_VERSION))'
DEB_INSTALL_DOCS_ALL += README.html README readme.jpn

CFLAGS += -D_REENTRANT -pipe

DEB_SHLIBDEPS_LIBRARY_ALL = -Llibgd2-noxpm -ldebian/libgd2-noxpm/usr/lib

# FIXME: Drop this when CDBS honors per-flavor configure flags
debian/stamp-autotools/noxpm: cdbs_configure_flags += $(DEB_CONFIGURE_FLAGS_noxpm)
debian/stamp-autotools/xpm: cdbs_configure_flags += $(DEB_CONFIGURE_FLAGS_xpm)

# put aside upstream-shipped tempfile during build but after copyright-check
upstreamtmpfiles = test/gdtest_wbmp_to_png.png
pre-build:: debian/stamp-upstreamtmpstuff
debian/stamp-upstreamtmpstuff: debian/stamp-copyright-check
	for file in $(upstreamtmpfiles); do \
		[ ! -e $$file ] || [ -e $$file.upstream ] || mv $$file $$file.upstream; \
	done
	touch $@
clean::
	for file in $(upstreamtmpfiles); do \
		[ ! -e $$file.upstream ] || mv -f $$file.upstream $$file; \
	done
	rm -f debian/stamp-upstreamtmpstuff

# build tests and more _after_ normal build routines
common-post-build-arch:: buildmore
buildmore: build/libgd2-noxpm
	LD_PRELOAD=$(CURDIR)/build/noxpm/.libs/libgd.so $(CURDIR)/build/noxpm/gddemo
	LD_PRELOAD=$(CURDIR)/build/noxpm/.libs/libgd.so $(CURDIR)/build/noxpm/gdtest demoin.png
	perl debian/doc_cleaner.pl index.html > README.html
	html2text -nobs < README.html > README

clean::
	rm -f README.html README
	cd test && rm -f gdtest.jpg gdtest.wbmp
	rm -f demoout.png demooutp.png demoout.gif demooutp.gif
	rm -rf build debian/tmp-libgd2-noxpm debian/tmp-libgd2-xpm

# Let d-shlibs handle dev package dependencies and shlib install
#  Strip pre-sarge X11 fallback dependencies (until fixed in d-shlibs itself)
binary-post-install/libgd2-noxpm::
	d-shlibmove --commit \
		--override 's/ | xlibs-dev (<< 4.3.0)//' \
		--override s/libstdc++6-dev// \
		--override s/libxml2-2-dev/libxml2-dev/ \
		--movedev "debian/tmp-$(cdbs_curpkg)/usr/include/*" usr/include/ \
		--movedev "debian/tmp-$(cdbs_curpkg)/usr/bin/gdlib-config" usr/bin/ \
		--suffix -noxpm --devsuffix -noxpm \
		debian/tmp-$(cdbs_curpkg)/usr/lib/$(libname).so

binary-post-install/libgd2-xpm::
	d-shlibmove --commit \
		--override 's/ | xlibs-dev (<< 4.3.0)//' \
		--override s/libstdc++6-dev// \
		--override s/libxml2-2-dev/libxml2-dev/ \
		--movedev "debian/tmp-$(cdbs_curpkg)/usr/include/*" usr/include/ \
		--movedev "debian/tmp-$(cdbs_curpkg)/usr/bin/gdlib-config" usr/bin/ \
		--suffix -xpm --devsuffix -xpm \
		debian/tmp-$(cdbs_curpkg)/usr/lib/$(libname).so

# Needed by upstream for all flavors
CDBS_BUILD_DEPENDS += , libpng12-dev, libz-dev, libjpeg-dev

# Needed by upstream for xpm flavor
CDBS_BUILD_DEPENDS += , libfreetype6-dev, libxpm-dev, libx11-dev, libxt-dev, libfontconfig-dev

# Needed for our packaging
CDBS_BUILD_DEPENDS += , d-shlibs, html2text

common-install-arch::
	for file in debian/tmp-libgd2-xpm/usr/lib/*.la debian/tmp-libgd2-noxpm/usr/lib/*.la; do \
		sed -i "/dependency_libs/ s/'.*'/''/" $$file ; \
	done

## libgd2 2.0.36%7erc1%7edfsg

=== debian/changelog ===
libgd2 (2.0.36~rc1~dfsg-6ubuntu2.3) precise-security; urgency=medium

  * SECURITY UPDATE: denial of service via invalid read in
    gdImageCreateFromTiffPtr()
    - debian/patches/CVE-2016-6911.patch: check out of bounds reads in
      gd_io_dp.c.
    - CVE-2016-6911
  * SECURITY UPDATE: stack buffer overflow in dynamicGetbuf
    - debian/patches/CVE-2016-8670.patch: avoid potentially dangerous
      signed to unsigned conversion in gd_io_dp.c.
    - CVE-2016-8670

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 18 Oct 2016 14:24:19 +0200

libgd2 (2.0.36~rc1~dfsg-6ubuntu2.2) precise-security; urgency=medium

  * SECURITY UPDATE: integer overflow in _gd2GetHeader()
    - debian/patches/CVE-2016-5766.patch: check for overflow in gd_gd2.c.
    - CVE-2016-5766
  * SECURITY UPDATE: out of bounds read of masks array
    - debian/patches/CVE-2016-6161.patch: properly handle EOF marker in
      gd_gif_out.c.
    - CVE-2016-6161

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 08 Jul 2016 14:52:13 -0400

libgd2 (2.0.36~rc1~dfsg-6ubuntu2.1) precise-security; urgency=medium

  * SECURITY UPDATE: denial of service via crafted color table in XPM file
    - debian/patches/CVE-2014-2497.patch: avoid null-pointer dereference in
      gdxpm.c.
    - CVE-2014-2497
  * SECURITY UPDATE: denial of service via crafted GIF image
    - debian/patches/CVE-2014-9709-1.patch: fix buffer read overflow in
      gd_gif_in.c.
    - debian/patches/CVE-2014-9709-2.patch: move overflow test outside the
      loop in gd_gif_in.c.
    - CVE-2014-9709
  * SECURITY UPDATE: denial of service via crafted imagefilltoborder call
    - debian/patches/CVE-2015-8874.patch: add limits to gd.c.
    - CVE-2015-8874
  * SECURITY UPDATE: denial of service and possible code execution via
    crafted compressed gd2 data
    - debian/patches/CVE-2016-3074.patch: perform range checking in
      gd_gd2.c.
    - CVE-2016-3074

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 26 May 2016 10:01:57 -0400

libgd2 (2.0.36~rc1~dfsg-6ubuntu2) precise; urgency=low

  [ Kees Cook ]
  * debian/{control*,rules}: Added Multi-Arch support.
  * debian/rules: Drop .la file completely; not used by anything.

  [ Steve Langasek ]
  * Drop the autogeneration of debian/control, since this gives us a
    build-dep on non-multiarch-safe dh-buildinfo and wrong versioned
    build-deps on d-shlibs and cdbs.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Dec 2011 23:51:56 +0000

libgd2 (2.0.36~rc1~dfsg-6ubuntu1) precise; urgency=low

  * Resynchronise with Debian.  Remaining changes:
    - debian/control: Drop unnecessary build dependency 'gnulib'.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 18 Oct 2011 14:53:58 +0100

libgd2 (2.0.36~rc1~dfsg-5.1ubuntu2) precise; urgency=low

  * Rebuild for libjpeg8.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 18 Oct 2011 13:58:21 +0100

libgd2 (2.0.36~rc1~dfsg-5.1ubuntu1) oneiric; urgency=low

  * Merge from Debian unstable, remaining changes:
    - debian/control: Drop unnecessary build dependency 'gnulib'.
  * Dropped changes, merged in Debian:
    - debian/rules: clean the dependency_libs out of .la files at build
      time, per Policy 10.2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 04 Jun 2011 20:07:38 +0000

libgd2 (2.0.36~rc1~dfsg-5ubuntu2) natty; urgency=low

  * debian/rules: clean the dependency_libs out of .la files at build
    time, per Policy 10.2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 24 Mar 2011 13:14:55 -0700

libgd2 (2.0.36~rc1~dfsg-5ubuntu1) natty; urgency=low

  * Merge from debian unstable (LP: #689279). Remaining changes:
    - debian/control: Drop unnecessary build dependency 'gnulib'.

 -- Angel Abad <angelabad@ubuntu.com>  Mon, 13 Dec 2010 01:08:10 +0100

libgd2 (2.0.36~rc1~dfsg-3.2ubuntu1) maverick; urgency=low

  * Merge from Debian testing (LP: #606384). Remaining changes:
    - debian/control: Drop unnecessary build dependency 'gnulib'.

 -- Angel Abad <angelabad@gmail.com>  Wed, 05 May 2010 02:32:35 +0100

libgd2 (2.0.36~rc1~dfsg-3.1ubuntu1) lucid; urgency=low

  * Merge from debian testing.  Remaining changes:
    - debian/control: Drop unnecessary build dependency 'gnulib'.

 -- Kees Cook <kees@ubuntu.com>  Tue, 08 Dec 2009 16:59:29 -0800

libgd2 (2.0.36~rc1~dfsg-3ubuntu1) intrepid; urgency=low

  * Merge from debian unstable, remaining changes:
    - debian/control: Drop unnecessary build dependency 'gnulib'.

 -- Kees Cook <kees@ubuntu.com>  Sun, 03 Aug 2008 19:21:21 -0700

libgd2 (2.0.35.dfsg-3ubuntu2) hardy; urgency=low

  * debian/rules: Remove -Wl,--disable-rpath from CFLAGS, as this is not
    a valid linker option.  LP: #194518.
  * debian/rules: export the CFLAGS, so they're consistently used even
    when not called via dpkg-buildpackage.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 24 Feb 2008 07:10:48 +0000

libgd2 (2.0.35.dfsg-3ubuntu1) hardy; urgency=low

  * Merge from debian unstable, remaining changes:
    - debian/control: Drop unnecessary build dependency 'gnulib'.
    - maintainer field updates

 -- Kees Cook <kees@ubuntu.com>  Thu, 06 Dec 2007 17:02:21 -0800

libgd2 (2.0.34-1ubuntu1) gutsy; urgency=low

  * Merge from debian unstable, remaining changes:
    - debian/control: Drop unnecessary build dependency 'gnulib'.
    - maintainer field updates
  * gd_png.c: apply upstream fixes for endless loop bug.
  * References
    http://bugs.libgd.org/?do=details&task_id=86
    CVE-2007-2756

 -- Kees Cook <kees@ubuntu.com>  Mon, 11 Jun 2007 14:24:51 -0700

libgd2 (2.0.34~rc1-2ubuntu1) feisty; urgency=low

  * Merge from debian unstable, remaining changes:
    - debian/control: Drop unnecessary build dependency 'gnulib'.

 -- Kees Cook <kees@ubuntu.com>  Tue,  6 Feb 2007 21:15:32 -0800

libgd2 (2.0.34~rc1-2) unstable; urgency=high

  * Use CDBS-calculated DEB_UPSTREAM_VERSION for package dependencies
    (and locally-calculated version string only for soname). Fixes


=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: libgd2
 Section: graphics
 Priority: optional
-Maintainer: GD team <pkg-gd-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: GD team <pkg-gd-devel@lists.alioth.debian.org>
 Uploaders: Jonas Smedegaard <dr@jones.dk>, Sean Finney <seanius@debian.org>
 Build-Depends: autotools-dev,
- gnulib,
- cdbs (>= 0.4.72~),
+ cdbs (>= 0.4.93~),
  debhelper,
- dh-buildinfo,
  devscripts,
  libpng12-dev,
  libz-dev,
@@ -17,7 +16,7 @@
  libx11-dev,
  libxt-dev,
  libfontconfig-dev,
- d-shlibs,
+ d-shlibs (>= 0.48),
  html2text
 Vcs-Git: git://git.debian.org/git/collab-maint/libgd2
 Vcs-Browser: http://git.debian.org/?p=collab-maint/libgd2.git;a=summary
@@ -40,6 +39,7 @@
 
 Package: libgd2-xpm-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
 Depends: libgd2-xpm (= ${binary:Version}), ${devlibs:Depends}, ${misc:Depends}
 Conflicts: libgd-dev, libgd-noxpm-dev, libgd-xpm-dev, libgd2-noxpm-dev
@@ -56,6 +56,7 @@
 
 Package: libgd2-noxpm-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
 Depends: libgd2-noxpm (= ${binary:Version}), ${devlibs:Depends}, ${misc:Depends}
 Conflicts: libgd-dev, libgd-noxpm-dev, libgd-xpm-dev, libgd2-xpm-dev
@@ -72,7 +73,9 @@
 
 Package: libgd2-xpm
 Architecture: any
+Multi-Arch: same
 Section: libs
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: libgd2, libgd2-noxpm
 Provides: libgd2
@@ -89,7 +92,9 @@
 
 Package: libgd2-noxpm
 Architecture: any
+Multi-Arch: same
 Section: libs
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: libgd2, libgd2-xpm
 Provides: libgd2
